// WARPGATE FUNCTIONS //

package WGMod {
function brickWarpGate::onPlant(%data, %obj)
{
    Parent::onPlant(%data, %obj);
    
    //register this gate
    registerWarpGate(%obj, 0);
}

function brickWarpGateRO::onPlant(%data, %obj)
{
    Parent::onPlant(%data, %obj);
    
    //register this gate
    registerWarpGate(%obj, 1);
}

function brickWarpGateTO::onPlant(%data, %obj)
{
    Parent::onPlant(%data, %obj);
    
    //register this gate
    registerWarpGate(%obj, 2);
}

function brickWarpGate::onLoadPlant(%data, %obj)
{
    Parent::onLoadPlant(%data, %obj);

    //register this gate
    registerWarpGate(%obj, 0);  
}

function brickWarpGateRO::onLoadPlant(%data, %obj)
{
    Parent::onLoadPlant(%data, %obj);

    //register this gate
    registerWarpGate(%obj, 1);  
}

function brickWarpGateTO::onLoadPlant(%data, %obj)
{
    Parent::onLoadPlant(%data, %obj);

    //register this gate
    registerWarpGate(%obj, 2);  
}

function brickWarpGate::onRemove(%data, %obj)
{
   if(%obj.isPlanted())
      unRegisterWarpGate(%obj);
   Parent::onRemove(%data, %obj);
}

function brickWarpGate::onDeath(%data, %obj)
{
   if(%obj.isPlanted())
      unRegisterWarpGate(%obj);
   Parent::onDeath(%data, %obj);
}

function brickWarpGateTO::onRemove(%data, %obj)
{
   if(%obj.isPlanted())
      unRegisterWarpGate(%obj);
   Parent::onRemove(%data, %obj);
}

function brickWarpGateTO::onDeath(%data, %obj)
{
   if(%obj.isPlanted())
      unRegisterWarpGate(%obj);
   Parent::onDeath(%data, %obj);
}

function brickWarpGateRO::onRemove(%data, %obj)
{
   if(%obj.isPlanted())
      unRegisterWarpGate(%obj);
   Parent::onRemove(%data, %obj);
}

function brickWarpGateRO::onDeath(%data, %obj)
{
   if(%obj.isPlanted())
      unRegisterWarpGate(%obj);
   Parent::onDeath(%data, %obj);
}
function GameConnection::spawnPlayer(%this)
    {
        %return = parent::spawnPlayer(%this);
        %this.player.WarpGateLoop();
        return %return;
    }
};
activatePackage(WGMod);

// this is all Badspot's code so far btw; it begins to change here
function registerWarpGate(%obj, %type)
{
    if(%type > 2 || %type < 0) {
        echo("Invalid warpgate type!");
        return;
    }
    
   //get hash of this gate
   %hash = sha1(%obj.getPosition() @ %obj.angleId);
   
   echo("registering warpgate "@ %hash SPC "(Type" SPC %type @ ")");

   //see if gate is already registered - this should never happen
   if(%obj.isRegisteredWarpGate)
      return;
   for(%i = 0; %i < $WarpGates::NumGates; %i++)
   {
      if($WarpGates::GateHash[%i] $= %hash)
      {
         error("ERROR: registerWarpGate - gate " @ %obj.getid() @ " already registered");
         %obj.isRegisteredWarpGate = true;
         return;
      }
   }

   %obj.isRegisteredWarpGate = true;

   //convert null to 0
   $WarpGates::NumGates = mFloor($WarpGates::NumGates); 
   
   $WarpGates::GateType[%hash] = %type;
   $WarpGates::GateHash[$WarpGates::NumGates] = %hash;
   $WarpGates::GateID[%hash] = %obj.getid();
   $WarpGates::GateVisible[%hash] = 1;
   $WarpGates::GateNetwork[%hash] = "NONE";
   $WarpGates::NumGates++;
   
   %namenum = $WarpGates::NumGates;
   
   // now to unique-name the gate
   for(%i = 0; %i < $WarpGates::NumGates; %i++)
    {
        if($WarpGates::GateHash[%i] $= %hash)
            continue;
        
        %namenumword = "Gate_" @ %namenum;
        %foundhash = $WarpGates::GateHash[%i];
        %foundname = $WarpGates::GateChatName[%foundhash];
        
        if(%foundname $= %namenumword) {
            %namenum = %namenum + 1;
        }
    }
   
    $WarpGates::GateChatName[%hash] = "Gate_" @ %namenum;

   //echo(" NumGates " @ $WarpGates::NumGates);
}

function unRegisterWarpGate(%obj)
{
   //get hash of this gate
   %hash = sha1(%obj.getPosition() @ %obj.angleId);

   if(!%obj.isRegisteredWarpGate)
      return;

   echo("unregistering WarpGate "@ %hash);
   
   %obj.isRegisteredWarpGate = false;
   for(%i = 0; %i < $WarpGates::NumGates; %i++)
   {
      if($WarpGates::GateHash[%i] !$= %hash)
         continue;
      
      $WarpGates::GateHash[%i] = $WarpGates::GateHash[$WarpGates::NumGates-1];
      deleteVariables("$WarpGates::GateHash" @ $WarpGates::NumGates-1);
      $WarpGates::NumGates--;
      break;
   }

   //echo(" NumGates " @ $WarpGates::NumGates);

   deleteVariables("$WarpGates::GateID" @ %hash);
}

function dumpWarpGates()
{
   echo("                  =WARP GATES=                    ");
   echo("--------------------------------------------------");
   echo($WarpGates::NumGates @ " warp gates");
   for(%i = 0; %i < $WarpGates::NumGates; %i++)
   {
      %hash = $WarpGates::GateHash[%i];
      %id = $WarpGates::GateID[%hash];
      %type = $WarpGates::GateType[%hash];
      echo("Warp gate " @ %i @ "'s ID is " @ %id @ ", it's hash is " @ %hash @ " and it is type " @ %type);
   }
   echo("--------------------------------------------------");
}

function triggerWarpGate(%cl,%obj) {
    //get hash of this gate
    %hash = sha1(%obj.getPosition() @ %obj.angleId);
    
    // use that to find it in the tedious global variable list we made
    for(%i = 0; %i < $WarpGates::NumGates; %i++)
    {
        if($WarpGates::GateHash[%i] !$= %hash)
            continue;
        
        %gatehash = $WarpGates::GateHash[%i];
        %gatename = $WarpGates::GateChatName[%gatehash];
        %gatetype = $WarpGates::GateType[%gatehash];
        %gateid = $WarpGates::GateID[%gatehash];
        %gatenet = $WarpGates::GateNetwork[%gatehash];
    }
    
    %cl.ChatMessage("<color:ffffff>-= Warp Gate (<color:00ffff>" @ %gatename @ "<color:ffffff>) =-"); // yes, I use RRGGBB colorcode. fight me
    
    if(%gatetype == 1) { // trainsmit only
        %cl.ChatMessage("<color:ff0000>You cannot warp from this gate. (Receive Only)");
        return;
    }
    
    if(!%gateid.isRayCasting() == 1) {
        %cl.ChatMessage("<color:ff0000>You cannot warp from this gate. (Disabled)");
        return;
    }
    if(!$Pref::Warp::Showlists == 1) {
        %cl.ChatMessage("<color:ffff00>Use (/warpto [gatename]) to warp!");
        return;
    }
    %cl.ChatMessage("<color:00ffff>Other Gates<color:ffffff>:");
    
    // now we find all the rest :C
    for(%i = 0; %i < $WarpGates::NumGates; %i++)
    {
        if($WarpGates::GateHash[%i] $= %hash)
            continue;
        
        %foundhash = $WarpGates::GateHash[%i];
        %foundname = $WarpGates::GateChatName[%foundhash];
        %foundID = $WarpGates::GateID[%foundhash];
        %foundNet = $WarpGates::GateNetwork[%foundhash];

        if(!$WarpGates::GateVisible[%foundhash] == 1) {
            continue; // hidden gates don't show in the list, though they can still have names
        }
        
        if(%foundNet !$= %gatenet) {
            continue; // Networks can't be seen into or out of
        }
        
        %foundagate = 1;
        
        if(!%foundid.isRayCasting() == 1) {
            %cl.ChatMessage("<color:ff0000>" @ %foundname SPC "<color:ffffff> (Disabled)");
            continue;
        }
        
        if($WarpGates::GateType[%foundhash] < 2) {
            %cl.ChatMessage("<color:00ff00>" @ %foundname);
        }
        if($WarpGates::GateType[%foundhash] == 2) {
            %cl.ChatMessage("<color:ff0000>" @ %foundname SPC "<color:ffffff> (Transmit Only)");
        }
    }
    
    if(!%foundagate == 1) {
        %cl.ChatMessage("<color:ff0000>No gates found.");
    }
    
    %cl.ChatMessage("<color:ffffff>-------------------------------------");
    %cl.ChatMessage("<color:ffff00>Use (/warpto [gatename]) to warp!");
    %cl.ChatMessage("<color:ffffff>(Page Up if you didn't catch all of that.)");
}

function servercmdwarpto(%cl,%target) {
    if(!%cl.player.onwarpgate == 1) {
        %cl.ChatMessage("<color:ff0000>Can't use (/warpto) without a warp gate brick.");
        return;
    }
    
    %gatefound = 0;
    %hash = sha1(%cl.curgate.getPosition() @ %cl.curgate.angleId);
    
    // use that to find it in the tedious global variable list we made
    for(%i = 0; %i < $WarpGates::NumGates; %i++)
    {
        if($WarpGates::GateHash[%i] !$= %hash)
            continue;
        
        %gatehash = $WarpGates::GateHash[%i];
        %currentgate = $WarpGates::GateChatName[%gatehash];
        %gateid = $WarpGates::GateID[%gatehash];
        %gatetype = $WarpGates::GateType[%gatehash];
        %gatenetwork = $WarpGates::GateNetwork[%gatehash];
        break;
    }
    
    if(%gatetype == 1) {
        %cl.ChatMessage("<color:ff0000>This warpgate is receive-only.");
        return;
    }
    
    if(%target $= %currentgate) {
        %cl.ChatMessage("<color:ff0000>You're standing on that one.");
        return;
    }
    
    for(%i = 0; %i < $WarpGates::NumGates; %i++)
    {
        %hash = $WarpGates::GateHash[%i];
        %name = $WarpGates::GateChatName[%hash];
        %type = $WarpGates::GateType[%hash];
        %id = $WarpGates::GateID[%hash];
        %net = $WarpGates::GateNetwork[%hash];
        
        if(%name !$= %target) {
            continue;
        }
        
        if(%net !$= %gatenetwork) {
            %cl.ChatMessage("<color:ff0000>A gate with that name does exist, but it is not part of this network.");
            return;
        }
        
        if(!%id.isRayCasting() == 1) {
            %cl.ChatMessage("<color:ff0000>Sorry, that warpgate is disabled.");
            return;
        }
        
        if(%type == 2) {
            %cl.ChatMessage("<color:ff0000>Sorry, that's a transmit-only warpgate.");
            return;
        }
        
        %id = $WarpGates::GateID[%hash];
        %pos = %id.getTransform();
        %gatefound = 1;
    }
    if(%gatefound == 0) {
        %cl.ChatMessage("<color:ff0000>Sorry, but that gate could not be found.");
        return;
    }
    
    %cl.play2D(WarpTeleSound);
    %cl.player.setWhiteOut(1);
    %cl.player.setTransform(vectorAdd(%pos,"0 0 0.2"));
    %cl.player.onwarpgate = 0;
}

function Player::GateBrickCheck(%this)
{
	InitContainerRadiusSearch(%this.getPosition(),1,$TypeMasks::FxBrickObjectType);
    while((%targetObject=containerSearchNext()) !$= 0) {
        if(%targetObject.getDatablock().getName() $= "brickWarpGate") {
            return %targetObject;
        }
        if(%targetObject.getDatablock().getName() $= "brickWarpGateRO") {
            return %targetObject;
        }
        if(%targetObject.getDatablock().getName() $= "brickWarpGateTO") {
            return %targetObject;
        }
    }
    return 0;
}

function Player::WarpGateLoop(%this) {
    %client = %this.client;
    if(%this.gateBrickCheck() > 0) {
        if(!%this.onwarpgate == 1) {
            %this.onwarpgate = 1;
            %obj = %this.gateBrickCheck();
            %client.curgate = %obj;
            
            triggerWarpGate(%client,%obj);
        }
    } else {
        %this.onwarpgate = 0;
    }
    
    %this.schedule(110,WarpGateLoop);
}

function brickWarpGate::onPlant(%data, %obj)
{
   %obj.enableTouch = true;
}

function servercmdrenamewarpgate(%cl,%name) { // "/renamewarpgate [name]"
    if(!%cl.player.onwarpgate == 1) {
        %cl.ChatMessage("<color:ff0000>Can't use (/renamewarpgate) without a warp gate brick.");
        return;
    }
    
    %hash = sha1(%cl.curgate.getPosition() @ %cl.curgate.angleId);
    
    for(%i = 0; %i < $WarpGates::NumGates; %i++)
    {
        if($WarpGates::GateHash[%i] !$= %hash)
            continue;
        
        %gatehash = $WarpGates::GateHash[%i];
        %currentgate = $WarpGates::GateChatName[%gatehash];
        %curgatebrick = $WarpGates::GateID[%gatehash];
        break;
    }
    
    if(%curgatebrick.getGroup().bl_id == %cl.bl_id) {
        for(%i = 0; %i < $WarpGates::NumGates; %i++)
        {
            if($WarpGates::GateHash[%i] $= %hash)
                continue;
        
            %namenumword = %name;
            %foundhash = $WarpGates::GateHash[%i];
            %foundname = $WarpGates::GateChatName[%foundhash];
            
            if(%foundname $= %namenumword) {
                %cl.ChatMessage("<color:ff0000>A warp gate already exists with the name '" @ %name @ "'!");
                return;
            }
        }
        
        %cl.ChatMessage("<color:ffffff>Successfully changed warpgate name from " @ %currentgate @ " to " @ %name);
        $WarpGates::GateChatName[%gatehash] = %name;
        %cl.player.onwarpgate = 0; // reset player to avoid namebugs
    } else {
        %cl.ChatMessage("<color:ff0000>Sorry, but only the owner of this warpgate can do that.");
    }
}

function servercmdchangegatenetwork(%cl,%name) { // "/changegatenetwork [name]"
    if(!%cl.player.onwarpgate == 1) {
        %cl.ChatMessage("<color:ff0000>Can't use (/changegatenetwork) without a warp gate brick.");
        return;
    }
    
    %hash = sha1(%cl.curgate.getPosition() @ %cl.curgate.angleId);
    
    for(%i = 0; %i < $WarpGates::NumGates; %i++)
    {
        if($WarpGates::GateHash[%i] !$= %hash)
            continue;
        
        %gatehash = $WarpGates::GateHash[%i];
        %currentgate = $WarpGates::GateChatName[%gatehash];
        %curgatebrick = $WarpGates::GateID[%gatehash];
        %curnet = $WarpGates::GateNetwork[%gatehash];
        break;
    }
    
    if(%curgatebrick.getGroup().bl_id == %cl.bl_id) {
        %cl.ChatMessage("<color:ffffff>Successfully changed warpgate network from " @ %curnet @ " to " @ %name);
        $WarpGates::GateNetwork[%gatehash] = %name;
        %cl.player.onwarpgate = 0; // reset player to avoid netbugs
    } else {
        %cl.ChatMessage("<color:ff0000>Sorry, but only the owner of this warpgate can do that.");
    }
}

function servercmdtogglegatevisibility(%cl) { // "/togglegatevisibility"
    if(!%cl.player.onwarpgate == 1) {
        %cl.ChatMessage("<color:ff0000>Can't use (/togglegatevisibility) without a warp gate brick.");
        return;
    }
    
    %hash = sha1(%cl.curgate.getPosition() @ %cl.curgate.angleId);
    
    for(%i = 0; %i < $WarpGates::NumGates; %i++)
    {
        if($WarpGates::GateHash[%i] !$= %hash)
            continue;
        
        %gatehash = $WarpGates::GateHash[%i];
        %currentgateisvisible = $WarpGates::GateVisible[%hash];
        %curgatebrick = $WarpGates::GateID[%hash];
        break;
    }
    
    if(%currentgateisvisible == 1) {
        if(!%curgatebrick.getGroup().bl_id == %cl.bl_id) {
            %cl.ChatMessage("<color:ff0000>Sorry, but only the owner of this warpgate can do that.");
            return;
        }
        $WarpGates::GateVisible[%gatehash] = 0;
        %cl.ChatMessage("<color:ffffff>Gate visibility <color:ff0000>OFF<color:ffffff>.");
    } else {
        if(!%curgatebrick.getGroup().bl_id == %cl.bl_id) {
            %cl.ChatMessage("<color:ff0000>Sorry, but only the owner of this warpgate can do that.");
            return;
        }
        $WarpGates::GateVisible[%gatehash] = 1;
        %cl.ChatMessage("<color:ffffff>Gate visibility <color:00ff00>ON<color:ffffff>.");
    }
}